Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 980)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoLodStripsLibrary.h	(revision 1007)
@@ -78,4 +78,5 @@
 			SmallInt	mTotalStrips;		///Total strips of the multiresolution object.
 			SmallInt	mTotalVertices;	///Total vertices of the multiresolution object.
+			SmallInt	mMaxVerticesLOD;///Number of vertices of the max LOD.
 			SmallInt	mTotalChanges;	///Total changes of the multiresolution object.
 			SmallInt	mLods;					///Available Lods.
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h	(revision 986)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimpSequence.h	(revision 1007)
@@ -48,8 +48,13 @@
 			struct Step
 			{
-				Index mV0, mV1;
-				Index mT0, mT1;
-				float x,y,z;
-				std::vector<Index> mModfaces;
+				Index mV0;
+				Index	mV1;
+				Index mT0;
+				Index	mT1;
+				float x;
+				float	y;
+				float	z;
+				
+				std::vector<Index>	mModfaces;
 
 				//	Indicates the the step is obligatory to execute
@@ -78,2 +83,3 @@
 
 #endif
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h	(revision 980)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoMeshSimplifier.h	(revision 1007)
@@ -6,4 +6,5 @@
 #include	"GeoMeshSimpSequence.h"
 #include	"vmi_simplifier.h"
+#include	"change.h"
 
 //#include "SimplificationMethod.h"
@@ -86,4 +87,7 @@
 		void	findVertex(size_t	submesh, size_t	index);
 		
+		//	Gets the VMI mesh simplification sequence.
+		void	GetMeshSimpSequence();
+
 	public:
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoTreeSimplifier.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoTreeSimplifier.h	(revision 774)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/include/GeoTreeSimplifier.h	(revision 1007)
@@ -6,6 +6,8 @@
 #include "Hoja.h"
 
-#define K1		0.8f //distancia
-#define K2		0.2f // coplanar
+#define K1		0.8f //distance factor
+#define K2		0.2f //coplanar factor
+
+class LeafOctree;
 
 namespace Geometry
@@ -34,15 +36,8 @@
 	public:
 		/// Class constructor. Retrieves a pointer to a valid Mesh object to simplify
-		TreeSimplifier(	const Geometry::Mesh 	*,
-										Geometry::TIPOFUNC		upb=0);
+		TreeSimplifier(const Geometry::Mesh *, Geometry::TIPOFUNC upb=0);
 
 		/// Class destructor.
 		~TreeSimplifier(void);
-
-		/// Copy constructor
-		//TreeSimplifier(const TreeSimplifier&);
-
-		/// Assignment operator
-		//TreeSimplifier& operator =(const TreeSimplifier&);
 
 		/// Starts the simplification process. Receives as a parameter the LOD factor in a range of [0,1].
@@ -55,41 +50,52 @@
 		TreeSimplificationSequence *GetSimplificationSequence();
 
-	//private:
-		void Centroh(Hoja	&);
-		void GetNormal(Hoja	&);
-		void DistanciaEntreHojas(void);
-		void CoplanarEntreHojas(FILE*);
-		float DiametroEsferaEnvolvente();
-		void EstableceCriterio(float);
+	private:
+		void CalculateLeafCenter(Hoja &);
+		void CalculateLeafNormal(Hoja &);
+		float CalculateLeafArea(Hoja &) const;
+		void CoplanarBetweenLeaves(void);
+		float BoundingSphereDiameter() const;
+//		void SetCriteria(float);  // to be erased: obsolete!
+		void SetCriteriaOptimized(float);
 
-		float max(float, float);
-		float min(float, float);
+		float max(float, float) const;
+		float min(float, float) const;
 
-		//long int Colapsa (TreeSimplificationSequence *, float);
-		long int Colapsa(float);
-		void DosMayores(float*, int* );
-		void ElijeVertices(Hoja& , Hoja& , long int);
-		float Hausdorff(Hoja &, Hoja&);
-		float distan(float, float, float, float, float, float);
-		long int MinimaDistancia(void);
-		void NormalizaDistancia(float diametro);
-		void EstableceCriterio2(float, long int);
-		long int MinimoCriterio(void);
+		long int Collapse(float);
+		void TwoGreater(float*, int* );
+		void ChooseVertices(Hoja& , Hoja& , long int);
+		float HausdorffOptimized(const Hoja &, const Hoja&) const;
+		float DistanceFromCenters(const Hoja &, const Hoja &) const;
+		float distan(float, float, float, float, float, float) const;
+		long int MinDistance(void);
+		void NormalizeDistance(float diametro);
+//		void SetCriteria2(float, long int); obsolete!
+		void SetCriteria2Optimized(float, long int);
+		long int MinCriteria(void);
 
-		void Mesh2Estructura(	const Geometry::Mesh *,
-													Index);
-		
-		void EscribeMesh(int);
+		void Mesh2Structure(const Geometry::Mesh *,Index);
+		void BuildOutputMesh(int);
+		void CrossProduct(const float *v1, const float *v2, float *res) const;
+		float SquaredModule(const float *v) const;
 
-		Mesh			*mesh; // objeto mesh simplificado (para la salida)
+		Mesh			*mesh; // simplified mesh object (for output)
 		const			Mesh *objmesh;
 		float			(*Vertex)[3];
-		Hoja			*Hojasa;  // las activas
-		long int	activas, counth;
+		Hoja			*Leaves;
+		long int	activeLeaves, countLeaves;
 		TreeSimplificationSequence	*mtreesimpsequence;
 		
-	private:
 		//	Update progress bar.
 		Geometry::TIPOFUNC	mUPB;
+
+		// the octree used to speed up the simplification process
+		LeafOctree *octree;
+		void RecursiveCreateLeafOctree(LeafOctree*, int deep); // this is called from CreateLeafNode
+		void RecursiveFillOctreeWithLeaves(LeafOctree*);
+		LeafOctree* CreateLeafOctree(int deep); // generates a new leaf octree and returns its root node
+		int vertex_count;
+		LeafOctree ** octree_owning_leaf;
+		LeafOctree *GetMinOctreeNodeForLeaf(LeafOctree *start, const Hoja &leaf);
+		bool PruneOctree(LeafOctree *); // erases one octree level and translates its leaves to the parent. Returns true if the node itself was pruned
 	};
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsLibrary.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsLibrary.cpp	(revision 985)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodStripsLibrary.cpp	(revision 1007)
@@ -327,9 +327,5 @@
 uint32	LodStripsLibrary::MaxVertices()
 {
-	uint32	number_of_vertices;
-
-	number_of_vertices	=	mTotalVertices;
-
-	return	number_of_vertices;
+	return	mMaxVerticesLOD;
 }
 
@@ -340,5 +336,5 @@
 
 	//	Total vertices less total lod.
-	number_of_vertices	=	mTotalVertices - (mMaxLod + 1);
+	number_of_vertices	=	mMaxVerticesLOD - (mMinLod + 1);
 
 	return	number_of_vertices;
@@ -394,4 +390,7 @@
 void		LodStripsLibrary::TrimByLod(uint32 minLod, uint32 maxLod)
 {
+	//	Refresh number of vercies of the max lod.
+	mMaxVerticesLOD	+=	mMaxLod - maxLod;
+	
 	mMinLod	=	minLod;
 	mMaxLod	=	maxLod;
@@ -621,6 +620,6 @@
 		//	Max / Min values for LOD.
 		mLods											=	int(p_changes.size());
-		mMinLod										=	0;
-		mMaxLod										=	mLods;
+		mMaxLod										=	0;
+		mMinLod										=	mLods;
 
 		//// CHAPUZA PROVISIONAL: EL ULTIMO ELEMENTO SE REPITE 2 VECES V.v
@@ -632,7 +631,8 @@
 		}
 
-		mTotalVertices			=	int(mFileVertices.size());
-		mTotalStrips				=	int(mFileStrips.size());
-		mTotalChanges				=	int(mFileChangesLOD.size());
+		mTotalVertices		=	int(mFileVertices.size());
+		mMaxVerticesLOD		=	mTotalVertices;
+		mTotalStrips			=	int(mFileStrips.size());
+		mTotalChanges			=	int(mFileChangesLOD.size());
 
 		//Copy the data to the structure we will use
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/include/change.h	(revision 1007)
@@ -2,40 +2,65 @@
 #define __change_h_
 
-#include "mesh.h"
+#include	"mesh.h"
+#include	<vector>
 
 namespace	VMI
 {
-typedef struct change {
-  int e;
-  int u, v;           // Edge
-  int numDel;         // Number of deleted triangles
-  Triangle *deleted;  // List of deleted triangles 
-  int numMod;         // Number of modified triangles 
-  Triangle *modified; // List of triangles deleted  
-} Change;
+	typedef struct change
+	{
+		int e;
+		int u, v;           // Edge
+		int numDel;         // Number of deleted triangles
+		Triangle *deleted;  // List of deleted triangles 
+		int numMod;         // Number of modified triangles 
+		Triangle *modified; // List of triangles deleted  
+	} Change;
 
-extern Change *createChange (Mesh *mesh, int e);
-extern void writeChange(FILE* file, Change *c);
-extern void deleteChange(Change *c);
-extern void printChange(Change *c);
+	// Represents a simplification step in the sequence.
+	struct vmiStep
+	{
+		unsigned int	mV0;
+		unsigned int	mV1;
+		unsigned int	mT0;
+		unsigned int	mT1;
+		float x;
+		float	y;
+		float	z;
+		
+		std::vector<unsigned int>	mModfaces;
 
-extern void modifyTriangle(Triangle *t, int c, int p);
-extern int isATriangleToModify(Triangle *t, int c, int p);
-extern int getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified);
-extern int isATriangleToDelete(Triangle *t, int c, int p);
-extern int getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p);
+		//	Indicates the the step is obligatory to execute
+		//	joined width the following step.
+		unsigned int obligatory;
+	};
 
-extern void modifyTriangles(Mesh *mesh, Change *c);
-extern void unmodifyTriangles(Mesh *mesh, Change *c);
-extern void deleteTriangles(Mesh *mesh, Change *c);
-extern void undeleteTriangles(Mesh *mesh, Change *c);
+	// Stores all the simplification steps.
+	extern	std::vector<vmiStep> mVMISteps;
 
-extern void printList(Triangle *list, int n);
-extern void deleteItem(Triangle *list, int *n, int item);
+	extern Change *createChange (Mesh *mesh, int e);
+	extern void writeChange(FILE* file, Change *c);
+	extern void deleteChange(Change *c);
+	extern void printChange(Change *c);
 
-extern void doChange(Mesh *mesh, Change *c);
-extern void undoChange(Mesh *mesh, Change *c);
-extern void computeChanges(Mesh *mesh, Change *c);
+	extern void modifyTriangle(Triangle *t, int c, int p);
+	extern int isATriangleToModify(Triangle *t, int c, int p);
+	extern int getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified);
+	extern int isATriangleToDelete(Triangle *t, int c, int p);
+	extern int getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p);
 
+	extern void modifyTriangles(Mesh *mesh, Change *c);
+	extern void unmodifyTriangles(Mesh *mesh, Change *c);
+	extern void deleteTriangles(Mesh *mesh, Change *c);
+	extern void undeleteTriangles(Mesh *mesh, Change *c);
+
+	extern void printList(Triangle *list, int n);
+	extern void deleteItem(Triangle *list, int *n, int item);
+
+	extern void doChange(Mesh *mesh, Change *c);
+	extern void undoChange(Mesh *mesh, Change *c);
+	extern void computeChanges(Mesh *mesh, Change *c);
+
+	//	Save simplification sequence in Geometry Game Tools format.
+	extern void	saveSimplificationSequence(Change	*c);
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp	(revision 1007)
@@ -9,4 +9,6 @@
 
 using namespace VMI;
+
+std::vector<VMI::vmiStep> VMI::mVMISteps;
 
 Change *VMI::createChange (Mesh *mesh, int e) {
@@ -29,205 +31,228 @@
 }
 
-void VMI::deleteChange(Change *c) {
-    
-    if (NULL != c) {
-        if (c->deleted != NULL)   free(c->deleted);
-        if (c->modified != NULL)  free(c->modified);
-        c->modified = NULL;
-        c->deleted = NULL;
-        c->numDel = 0;
-        c->numMod = 0;
-        
-        free(c);
-        c = NULL;
-    }
-}
-
-void VMI::writeChange(FILE* file, Change *c) {
-    int i;
-
-    fputc('v',file);
-    fputc('%',file);
-    fprintf(file, " %d %d 0 0 0 ", c->v, c->u);
-
-    for (i=0; i<c->numDel; i++) {
-        fprintf(file, "%d ", c->deleted[i].id);
-    }
-
-    fputc('&',file);
-    for (i=0; i<c->numMod; i++) {
-        fprintf(file, " %d", c->modified[i].id);
-    }
-
-    fputc('\n',file);
-}
-
-void VMI::printChange(Change *c) {
-    int i;
-    
-    if (NULL != c) {
-        
-        printf("e%d(%d,%d)\n",c->e,c->u,c->v);
-        
-        printf("d %d\n", c->numDel);
-        for (i=0;i<c->numDel;i++) {
-            printf(" %d", c->deleted[i].id);
-        }
-        printf("\n");
-        printf("m %d\n", c->numMod);
-        for (i=0;i<c->numMod;i++) {
-            printf(" %d", c->modified[i].id);
-        }
-        printf("\n");
-    }
-}
-
-void VMI::modifyTriangle(Triangle *t, int c, int p) {
-    
-    if ((int)t->indices[0] == c)
-        t->indices[0]= p;
-    if ((int)t->indices[1] == c)
-        t->indices[1]= p;
-    if ((int)t->indices[2] == c)
-        t->indices[2]= p;
-}
-
-int VMI::isATriangleToModify(Triangle *t, int c, int p) {
-    int u = t->indices[0],
-        v = t->indices[1],
-        w = t->indices[2];
-    
-    if ((u == c) || (v == c) || (w == c)) return TRUE;
-
-    return FALSE;
-}
-
-void VMI::modifyTriangles(Mesh *mesh, Change *c) {
-    int i, t;
-    
-    for (i=0; i<c->numMod; i++) {
-        t = c->modified[i].id;
-        modifyTriangle(&mesh->triangles[t], c->u, c->v);
-
-        //printf("New area of triangle %d:\n", t);
-        mesh->triangles[t].area = computeTriangleArea(mesh->vertices, &mesh->triangles[t]);
-
-        computeTriangleNormal(mesh->vertices, &mesh->triangles[t]);
-    }
-}
-
-void VMI::unmodifyTriangles(Mesh *mesh, Change *c) {
-    int i, t;
-    
-    for (i=0; i<c->numMod; i++) {
-        t = c->modified[i].id;
-
-        memcpy(&mesh->triangles[t], &c->modified[i], sizeof(Triangle));
-        /*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
-                                  mesh->triangles[t].indices[1],
-                                  mesh->triangles[t].indices[2]);*/
-    }
-}
-
-void VMI::deleteTriangles(Mesh *mesh, Change *c) {
-    int i, t;
-    
-    for (i=0; i<c->numDel; i++) {
-        t = c->deleted[i].id;
-
-        //printf("Deleting triangle %d\n",t);
-        mesh->triangles[t].enable = FALSE;
-        mesh->currentNumTriangles--;
-    }
-}
-
-void VMI::undeleteTriangles(Mesh *mesh, Change *c) {
-    int i, t;
-    
-    for (i=0; i<c->numDel; i++) {
-        t = c->deleted[i].id;
-        
-        memcpy(&mesh->triangles[t], &c->deleted[i], sizeof(Triangle));
-        /*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
-                                  mesh->triangles[t].indices[1], 
-                                  mesh->triangles[t].indices[2]);*/
-
-        mesh->triangles[t].enable = TRUE;
-        mesh->currentNumTriangles++;
-    }
-}
-
-int VMI::getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified) {
-    GLuint i, num = 0;
-    
-    for (i=0; i<mesh->numTriangles; i++) {
-        if ((mesh->triangles[i].enable == TRUE) && 
-            isATriangleToModify(&mesh->triangles[i], c, p)) {
-                                                     
-                //printf("Triangle to modify %d\n", i);
-                // Save the original values of the triangle
-                memcpy(&modified[num], &mesh->triangles[i], sizeof(Triangle));
-                num++;
-        }
-    }
-    
-    return num;
-}
-
-int VMI::isATriangleToDelete(Triangle *t, int c, int p) {
-    int u = t->indices[0],
-        v = t->indices[1],
-        w = t->indices[2];
-    
-    if (((u == c) && ( v == p)) ||
-        ((u == c) && ( w == p)) || 
-        ((v == c) && ( w == p)))
-        return TRUE;
-    if (((u == p) && ( v == c)) ||
-        ((u == p) && ( w == c)) || 
-        ((v == p) && ( w == c)))
-        return TRUE;
-
-    return FALSE;
-}
-
-int VMI::getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p) {
-    int i, num = 0;
-    GLuint t;
-    
-    for (i=0; i<numMod; i++) {
-        t = modified[i].id;
-        
-        if (isATriangleToDelete(&mesh->triangles[t], c, p)) {
-                                                     
-            //printf("Triangle to delete %d\n",t);                    
-            memcpy(&deleted[num], &modified[i], sizeof(Triangle));
-            num++;
-        }
-    }
-    return num;
-}
-
-void VMI::printList(Triangle *list, int n) {
-    int i;
-    
-    for (i=0; i<n; i++)
-        printf("%d ",list[i].id);
-
-    printf("\n");
-}
-
-void VMI::deleteItem(Triangle *list, int *n, int item) {
-    int i, j;
-    
-    for (i=0; i<*n; i++) {
-        if (list[i].id == (GLuint)item) {
-            // delete it
-            for (j =i + 1 ; j<*n; j++)
-                list[j - 1] = list[j];
-            (*n)--;
-            i--; // Delete all ocurrencies of an item
-        }
-    }
+void VMI::deleteChange(Change *c)
+{
+
+	if (NULL != c)
+	{
+		if (c->deleted != NULL)   free(c->deleted);
+		if (c->modified != NULL)  free(c->modified);
+		c->modified = NULL;
+		c->deleted = NULL;
+		c->numDel = 0;
+		c->numMod = 0;
+
+		free(c);
+		c = NULL;
+	}
+}
+
+void VMI::writeChange(FILE* file, Change *c)
+{
+	int i;
+
+	fputc('v',file);
+	fputc('%',file);
+	fprintf(file, " %d %d 0 0 0 ", c->v, c->u);
+
+	for (i=0; i<c->numDel; i++) {
+		fprintf(file, "%d ", c->deleted[i].id);
+	}
+
+	fputc('&',file);
+	for (i=0; i<c->numMod; i++) {
+		fprintf(file, " %d", c->modified[i].id);
+	}
+
+	fputc('\n',file);
+}
+
+void VMI::printChange(Change *c)
+{
+	int i;
+
+	if (NULL != c) {
+
+		printf("e%d(%d,%d)\n",c->e,c->u,c->v);
+
+		printf("d %d\n", c->numDel);
+		for (i=0;i<c->numDel;i++) {
+			printf(" %d", c->deleted[i].id);
+		}
+		printf("\n");
+		printf("m %d\n", c->numMod);
+		for (i=0;i<c->numMod;i++) {
+			printf(" %d", c->modified[i].id);
+		}
+		printf("\n");
+	}
+}
+
+void VMI::modifyTriangle(Triangle *t, int c, int p)
+{
+
+	if ((int)t->indices[0] == c)
+		t->indices[0]= p;
+	if ((int)t->indices[1] == c)
+		t->indices[1]= p;
+	if ((int)t->indices[2] == c)
+		t->indices[2]= p;
+}
+
+int VMI::isATriangleToModify(Triangle *t, int c, int p)
+{
+	int u = t->indices[0],
+			v = t->indices[1],
+			w = t->indices[2];
+
+	if ((u == c) || (v == c) || (w == c)) return TRUE;
+
+	return FALSE;
+}
+
+void VMI::modifyTriangles(Mesh *mesh, Change *c)
+{
+	int i, t;
+
+	for (i=0; i<c->numMod; i++)
+	{
+		t = c->modified[i].id;
+		modifyTriangle(&mesh->triangles[t], c->u, c->v);
+
+		//printf("New area of triangle %d:\n", t);
+		mesh->triangles[t].area = computeTriangleArea(mesh->vertices, &mesh->triangles[t]);
+
+		computeTriangleNormal(mesh->vertices, &mesh->triangles[t]);
+	}
+}
+
+void VMI::unmodifyTriangles(Mesh *mesh, Change *c)
+{
+	int i, t;
+
+	for (i=0; i<c->numMod; i++) {
+		t = c->modified[i].id;
+
+		memcpy(&mesh->triangles[t], &c->modified[i], sizeof(Triangle));
+		/*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
+			mesh->triangles[t].indices[1],
+			mesh->triangles[t].indices[2]);*/
+	}
+}
+
+void VMI::deleteTriangles(Mesh *mesh, Change *c)
+{
+	int i, t;
+
+	for (i=0; i<c->numDel; i++)
+	{
+		t = c->deleted[i].id;
+
+		//printf("Deleting triangle %d\n",t);
+		mesh->triangles[t].enable = FALSE;
+		mesh->currentNumTriangles--;
+	}
+}
+
+void VMI::undeleteTriangles(Mesh *mesh, Change *c)
+{
+	int i, t;
+
+	for (i=0; i<c->numDel; i++)
+	{
+		t = c->deleted[i].id;
+
+		memcpy(&mesh->triangles[t], &c->deleted[i], sizeof(Triangle));
+		/*printf("t(%d %d %d)\n", mesh->triangles[t].indices[0], 
+			mesh->triangles[t].indices[1], 
+			mesh->triangles[t].indices[2]);*/
+
+		mesh->triangles[t].enable = TRUE;
+		mesh->currentNumTriangles++;
+	}
+}
+
+int VMI::getTrianglesToModify(Mesh *mesh, int c, int p, Triangle *modified)
+{
+	GLuint i, num = 0;
+
+	for (i=0; i<mesh->numTriangles; i++)
+	{
+		if ((mesh->triangles[i].enable == TRUE) && 
+				isATriangleToModify(&mesh->triangles[i], c, p))
+		{
+
+			//printf("Triangle to modify %d\n", i);
+			// Save the original values of the triangle
+			memcpy(&modified[num], &mesh->triangles[i], sizeof(Triangle));
+			num++;
+		}
+	}
+
+	return num;
+}
+
+int VMI::isATriangleToDelete(Triangle *t, int c, int p)
+{
+	int u = t->indices[0],
+			v = t->indices[1],
+			w = t->indices[2];
+
+	if (((u == c) && ( v == p)) ||
+			((u == c) && ( w == p)) || 
+			((v == c) && ( w == p)))
+		return TRUE;
+	if (((u == p) && ( v == c)) ||
+			((u == p) && ( w == c)) || 
+			((v == p) && ( w == c)))
+		return TRUE;
+
+	return FALSE;
+}
+
+int VMI::getTrianglesToDelete(Mesh *mesh, int numMod, Triangle *modified, Triangle *deleted, int c, int p)
+{
+	int i, num = 0;
+	GLuint t;
+
+	for (i=0; i<numMod; i++)
+	{
+		t = modified[i].id;
+
+		if (isATriangleToDelete(&mesh->triangles[t], c, p))
+		{                                             
+			//printf("Triangle to delete %d\n",t);                    
+			memcpy(&deleted[num], &modified[i], sizeof(Triangle));
+			num++;
+		}
+	}
+	return num;
+}
+
+void VMI::printList(Triangle *list, int n)
+{
+	int i;
+
+	for (i=0; i<n; i++)
+		printf("%d ",list[i].id);
+
+	printf("\n");
+}
+
+void VMI::deleteItem(Triangle *list, int *n, int item)
+{
+	int i, j;
+
+	for (i=0; i<*n; i++)
+	{
+		if (list[i].id == (GLuint)item)
+		{
+			// delete it
+			for (j =i + 1 ; j<*n; j++)
+				list[j - 1] = list[j];
+			(*n)--;
+			i--; // Delete all ocurrencies of an item
+		}
+	}
 }
 
@@ -235,64 +260,111 @@
 
 // Compute the triangle mesh changes due to a heap node simplification
-void VMI::computeChanges(Mesh *mesh, Change *c) {
-    Triangle m[MAX_NUM_TRI], d[MAX_NUM_TRI/2];
-    int numMod = getTrianglesToModify(mesh, c->u, c->v, m);
-    int numDel = getTrianglesToDelete(mesh, numMod, m, d, c->u, c->v);
-    int i;
-    
-    //printf("d %d\n",numDel);
-    //printList(d, numDel);
-
-    for (i=0; i<numDel; i++)
-        deleteItem(m, &numMod, d[i].id);
-
-    //printf("m %d\n",numMod);
-    //printList(m, numMod);
-    //getchar();
-    
-    c->numDel = numDel;
-    // Free memory
-    if (c->deleted != NULL) free(c->deleted);
-    // Allocate memory
-    c->deleted = (Triangle *)malloc(sizeof(Triangle) * numDel);
-    if (c->deleted == NULL) {
-        fprintf(stderr, "Error allocating memory\n");
-        exit(1);
-    }
-    memcpy(c->deleted, d, sizeof(Triangle) * numDel);
-    
-    c->numMod = numMod;
-    // Free memory
-    if (c->modified != NULL) free(c->modified);
-    // Allocate memory
-    c->modified = (Triangle *)malloc(sizeof(Triangle) * numMod);
-    if (c->modified == NULL) {
-        fprintf(stderr, "Error allocating memory\n");
-        exit(1);
-    }
-    memcpy(c->modified, m, sizeof(Triangle) * numMod);
-
-    //printChange(c);
-    //getchar();
+void VMI::computeChanges(Mesh *mesh, Change *c)
+{
+	Triangle m[MAX_NUM_TRI], d[MAX_NUM_TRI/2];
+	int numMod = getTrianglesToModify(mesh, c->u, c->v, m);
+	int numDel = getTrianglesToDelete(mesh, numMod, m, d, c->u, c->v);
+	int i;
+
+	//printf("d %d\n",numDel);
+	//printList(d, numDel);
+
+	for (i=0; i<numDel; i++)
+		deleteItem(m, &numMod, d[i].id);
+
+	//printf("m %d\n",numMod);
+	//printList(m, numMod);
+	//getchar();
+
+	c->numDel = numDel;
+	// Free memory
+	if (c->deleted != NULL) free(c->deleted);
+	// Allocate memory
+	c->deleted = (Triangle *)malloc(sizeof(Triangle) * numDel);
+	
+	if (c->deleted == NULL)
+	{
+		fprintf(stderr, "Error allocating memory\n");
+		exit(1);
+	}
+	
+	memcpy(c->deleted, d, sizeof(Triangle) * numDel);
+
+	c->numMod = numMod;
+	
+	// Free memory
+	if (c->modified != NULL) free(c->modified);
+	
+	// Allocate memory
+	c->modified = (Triangle *)malloc(sizeof(Triangle) * numMod);
+	
+	if (c->modified == NULL)
+	{
+		fprintf(stderr, "Error allocating memory\n");
+		exit(1);
+	}
+	
+	memcpy(c->modified, m, sizeof(Triangle) * numMod);
+
+	//printChange(c);
+	//getchar();
 }
 
 // Update the triangle mesh due to a heap node simplification
-void VMI::doChange(Mesh *mesh, Change *c) {
-    
-    modifyTriangles(mesh, c);
-    
-    deleteTriangles(mesh, c);
-
-    mesh->vertices[c->u].enable = FALSE;
-    mesh->currentNumVertices--;
-}
-
-void VMI::undoChange(Mesh *mesh, Change *c) {
-    
-    unmodifyTriangles(mesh, c);
-    
-    undeleteTriangles(mesh, c);
-
-    mesh->vertices[c->u].enable = TRUE;
-    mesh->currentNumVertices++;
-}
+void VMI::doChange(Mesh *mesh, Change *c)
+{
+	modifyTriangles(mesh, c);
+
+	deleteTriangles(mesh, c);
+
+	mesh->vertices[c->u].enable = FALSE;
+	mesh->currentNumVertices--;
+}
+
+void VMI::undoChange(Mesh *mesh, Change *c)
+{    
+	unmodifyTriangles(mesh, c);
+
+	undeleteTriangles(mesh, c);
+
+	mesh->vertices[c->u].enable = TRUE;
+	mesh->currentNumVertices++;
+}
+
+//	Save simplification sequence in Geometry Game Tools format.
+extern void	VMI::saveSimplificationSequence(Change	*c)
+{
+	vmiStep	step;
+	step.mV0	=	c->u;
+	step.mV1	=	c->v;
+
+	//	If only one triangle has been deleted.
+	if (c->numDel == 1)
+	{
+		step.mT0	=	c->deleted[0].id;
+		step.mT1	=	c->deleted[0].id;
+	}
+	//	If two triangles have been deleted.
+	else
+	{
+		step.mT0	=	c->deleted[0].id;
+		step.mT1	=	c->deleted[1].id;
+	}
+
+	step.x	=	0.0;
+	step.y	=	0.0;
+	step.z	=	0.0;
+
+	//	Write obligatory field.
+	step.obligatory	=	0;
+
+	//	List of new triangles.
+	//	For each modified triangle.
+	for (int	i = 0;	i < c->numMod;	i++)
+	{
+		step.mModfaces.push_back(c->modified[i].id);
+	}
+
+	//	Add step to list of changes.
+	mVMISteps.push_back(step);
+}
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/simplify.cpp	(revision 1007)
@@ -424,97 +424,132 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-void VMI::simplifyModel(Mesh *mesh, GLuint numDemandedTri) {
-    int e;
-    Change *c;
-    FILE* file = NULL;
-    char s[MAX_CHAR];
-    double cost = 0.0;
-    bheap_t *h = NULL;
-    float	percent	=	(40.0) / (float)(mesh->numTriangles - numDemandedTri);
-
-    if (numDemandedTri > mesh->currentNumTriangles) return;
-
-    if (bSaveLog == TRUE) { // Save changes into a file
+void VMI::simplifyModel(Mesh *mesh, GLuint numDemandedTri)
+{
+	int			e;
+	Change	*c;
+	FILE		*file 					= NULL;
+	FILE		*file_simp_seq	=	NULL;
+	char		s[MAX_CHAR];
+	double	cost 						= 0.0;
+	bheap_t	*h 							= NULL;
+	float		percent	=	(40.0) / (float)(mesh->numTriangles - numDemandedTri);
+
+	if (numDemandedTri > mesh->currentNumTriangles)
+	{
+		return;
+	}
+
+	// Save changes into a file
+	if (bSaveLog == TRUE)
+	{
 #ifdef SALIENCY       
 #ifdef KL // Kullback-Leibler
-        sprintf(s,"%s_VKL_S.log", filename);
+		sprintf(s,"%s_VKL_S.log", filename);
 #endif
 #ifdef MI // Mutual Information
-        sprintf(s,"%s_VMI_S.log", filename);
+		sprintf(s,"%s_VMI_S.log", filename);
 #endif
 #ifdef HE // Hellinger
-        sprintf(s,"%s_VHE_S.log", filename);
+		sprintf(s,"%s_VHE_S.log", filename);
 #endif
 #ifdef CS // Chi-Square
-        sprintf(s,"%s_VCS_S.log", filename);
+		sprintf(s,"%s_VCS_S.log", filename);
 #endif
 #else
 #ifdef KL // Kullback-Leibler
-        sprintf(s,"%s_VKL.log", filename);
+		sprintf(s,"%s_VKL.log", filename);
 #endif
 #ifdef MI // Mutual Information
-        sprintf(s,"%s_VMI.log", filename);
+		sprintf(s,"%s_VMI.log", filename);
 #endif
 #ifdef HE // Hellinger
-        sprintf(s,"%s_VHE.log", filename);
+		sprintf(s,"%s_VHE.log", filename);
 #endif
 #ifdef CS // Chi-Square
-        sprintf(s,"%s_VCS.log", filename);
-#endif
-#endif
-        
-        glmWriteOBJ(pmodel, s, GLM_NONE);
-        
-        /* open the file */
-        file = fopen(s, "a+");
-        if (!file) {
-            fprintf(stderr, "simplifyModel() failed: can't open file \"%s\" to write.\n", s);
-            exit(1);
-        }
-    }
-
-    h = initHeap(mesh);
-
-    printf("Starting simplification...\n");
-
-    while (mesh->currentNumTriangles > numDemandedTri /*&& cost == 0.0*/) {
-        
-        // Get the edge that has the minimum cost
-        e = bh_min(h);
-
-        c = createChange(mesh, e);
-
-        // Apply the edge collapse
-        computeChanges(mesh, c);
-        doChange(mesh, c);
-
-        if (bSaveLog == TRUE) writeChange(file, c);
-
-        cost = h->a[h->p[e]].key;
-        printf("Edge collapse e%d(%d,%d) %f MIN d %d m %d\n",c->e, c->u, c->v, cost, c->numDel, c->numMod);
-
-        mesh->edges[e].enable = FALSE;
-        bh_delete(h, e);
-        
-        // Get projected areas after the edge collapse
-        getProjectedAreas(histogram, numCameras);
-
-        computeCameraIs(histogram, numCameras, initialIs);
-
-        // Update the heap according to the edge collapse
-        h = updateHeap(h, mesh, c);
-
-				mUPB((float)c->numDel * percent);
-
-        deleteChange(c);
-
-        printf("t %d\n", mesh->currentNumTriangles);
-    }
-
-    if (bSaveLog == TRUE) {
-        fclose(file);
-        printf("Log file written...Ok\n");
-    }
-
-    bh_free(h);
-}
+		sprintf(s,"%s_VCS.log", filename);
+#endif
+#endif
+
+		glmWriteOBJ(pmodel, s, GLM_NONE);
+
+		/* open the file */
+		file = fopen(s, "a+");
+		
+		if (!file)
+		{
+			fprintf(stderr, "simplifyModel() failed: can't open file \"%s\" to write.\n", s);
+			exit(1);
+		}
+	}
+
+	//	Open file of simplification sequence.
+	file_simp_seq	=	fopen("SimplifSequence.txt", "w");
+	
+	if (!file_simp_seq)
+	{
+		fprintf(stderr,
+						"simplifyModel() failed: ",
+						"can't open file \"SimplifSequence\" to write.\n");
+	}
+	
+	h = initHeap(mesh);
+
+	printf("Starting simplification...\n");
+
+	while (mesh->currentNumTriangles > numDemandedTri /*&& cost == 0.0*/)
+	{
+		// Get the edge that has the minimum cost
+		e = bh_min(h);
+
+		c = createChange(mesh, e);
+
+		// Apply the edge collapse
+		computeChanges(mesh, c);
+		doChange(mesh, c);
+
+		if (bSaveLog == TRUE) writeChange(file, c);
+
+		//	Write Simplification sequence.
+		saveSimplificationSequence(c);
+		
+		cost = h->a[h->p[e]].key;
+		
+		printf(	"Edge collapse e%d(%d,%d) %f MIN d %d m %d\n",
+						c->e,
+						c->u,
+						c->v,
+						cost,
+						c->numDel,
+						c->numMod);
+
+		mesh->edges[e].enable = FALSE;
+		
+		bh_delete(h, e);
+
+		// Get projected areas after the edge collapse
+		getProjectedAreas(histogram, numCameras);
+
+		computeCameraIs(histogram, numCameras, initialIs);
+
+		// Update the heap according to the edge collapse
+		h = updateHeap(h, mesh, c);
+
+		mUPB((float)c->numDel * percent);
+
+		deleteChange(c);
+
+		printf("t %d\n", mesh->currentNumTriangles);
+	}
+
+	if (bSaveLog == TRUE)
+	{
+		fclose(file);
+		printf("Log file written...Ok\n");
+	}
+
+	//	Close simplification sequence file.
+	fclose(file_simp_seq);
+
+	bh_free(h);
+}
+
